package com.example.flutterktmap.gmap

import android.content.Context
import android.util.Log
import android.view.View
import android.widget.TextView
import com.example.flutterktmap.FlutterktmapPlugin
import com.kt.maps.GMap
import com.kt.maps.GMapResultCode
import com.kt.maps.GMapView
import com.kt.maps.OnMapReadyListener
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.platform.PlatformView

//
class FlutterGMapView : PlatformView, MethodChannel.MethodCallHandler, OnMapReadyListener{
    companion object {
        const val viewType = "plugins.kt.map/gmapview"
    }
    private val TAG = "FlutterGMapView"
    private var context: Context? = null
    private var gMapView: GMapView? = null
    private var methodChannel: MethodChannel? = null
    private var gMap: GMap? = null

    constructor(context: Context?, messenger: BinaryMessenger?, id: Int) {
        this.context = context
        methodChannel = MethodChannel(messenger, "${viewType}_$id")
        methodChannel?.setMethodCallHandler(this)
    }
    override fun getView(): View? {
        if(gMapView == null) {
            gMapView = GMapView(FlutterktmapPlugin.currentActivity).apply {
                this.setOnMapReadyListener(this@FlutterGMapView)
            }
        }
        return gMapView?.rootView
    }

    override fun dispose() {}

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        when (call.method) {
            "addOverlay" -> {
//                call.ar
            }
            else -> {
            }
        }
    }

    fun addOverlay() {
//        gMap?.addOverlay()
    }
    

    override fun onFailReadyMap(p0: GMapResultCode?) {
        Log.i(TAG, "onFailReadyMap $p0")
    }

    override fun onMapReady(p0: GMap?) {
        Log.i(TAG, "onMapReady")
        this.gMap = p0
    }
}