package com.example.flutterktmap.textview

import android.content.Context
import android.view.View
import android.widget.TextView
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.platform.PlatformView


class FlutterTextView : PlatformView, MethodChannel.MethodCallHandler{
    private var textView: TextView? = null
    private var methodChannel: MethodChannel? = null

    constructor(context: Context?, messenger: BinaryMessenger?, id: Int) {
        textView = TextView(context)
        methodChannel = MethodChannel(messenger, "plugins.felix.angelov/textview_$id")
        methodChannel?.setMethodCallHandler(this)
    }

    override fun getView(): View? {
        return textView
    }

    override fun dispose() {

    }


    override fun onMethodCall(methodCall: MethodCall, result: MethodChannel.Result) {
        when (methodCall.method) {
            "setText" -> setText(methodCall, result)
            else -> result.notImplemented()
        }
    }

    private fun setText(methodCall: MethodCall, result: MethodChannel.Result) {
        val text = methodCall.arguments as String
        textView!!.text = text
        result.success(null)
    }

}